VERSION 5.00
Begin VB.UserControl chameleonButton 
   AutoRedraw      =   -1  'True
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   DefaultCancel   =   -1  'True
   ScaleHeight     =   240
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   320
   ToolboxBitmap   =   "chameleonButton.ctx":0000
   Begin VB.Timer OverTimer 
      Enabled         =   0   'False
      Interval        =   5
      Left            =   0
      Top             =   0
   End
End
Attribute VB_Name = "chameleonButton"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Private Const Version As String = "1.1"

'%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
'%             <<< GONCHUKI SYSTEMS >>>               %
'%                                                    %
'%                 CHAMELEON BUTTON                   %
'%         copyright 2001-2002 by gonchuki           %
'%                                                    %
'%  this custom control will emulate the most common  %
'%      command buttons that everyone knows.          %
'%                                                    %
'% it took me about two months to develop this control%
'%  and at this time i think it's completely bug free %
'%     ALL THE CODE WAS WRITTEN FROM SCRATCH!!!       %
'%                                                    %
'%   ever wanted to add cool buttons to your app???   %
'%          this is the BEST solution!!!              %
'%                                                    %
'%                                                    %
'%     e-mail: gonchuki@yahoo.es                      %
'%                                                    %
'%              Don't forget to vote!!!               %
'%                                                    %
'%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

'######################################################
'#                    UPDTATE LOG                     #
'#  all times are GMT -03:00                          #
'#                                                    #
'# November 9  - 03:00 am                             #
'#               first release                       #
'#                                                    #
'# November 9  - 05:00 pm                             #
'#               added ShowFocusRect property        #
'#               added repaint before triggering the #
'#                click event                         #
'#                                                    #
'# November 9  - 07:20 pm                             #
'#               fixed the color shifting so it will #
'#                display the correct color and not a #
'#                weird one.                          #
'#               improved Java button drawing        #
'#               added custom colors capability      #
'#                now it looks better than ever COOL! #
'#               improved Flat button drawing        #
'#                                                    #
'# November 13 - 03:40 pm                             #
'#               fixed the WinXP button colors and   #
'#                styles. Note that as the colors are #
'#                relative to a base, and for this    #
'#                button i made a color work-around,  #
'#                some colors will be un-reachable    #
'#               added MouseMove event as requested  #
'#                                                    #
'# November 18 - 10:40 am                             #
'#               translated all the line methods to  #
'#                API calls. It's now faster than     #
'#                ever. It will also decrease the     #
'#                extra size of your exe!!!           #
'#               improved Win32 button drawing       #
'#               moved the direct calls to SetPixel  #
'#                to use less inline .hDC calls       #
'#               fixed KeyDown/KeyUp events so they  #
'#                now act as they should              #
'#                                                    #
'# November 23 - 3:55 pm  (not updating on PSC...)    #
'#               upgraded version to 1.1             #
'#               added FontBold, and other similar   #
'#                properties as requested             #
'#               greatly improved drawing speed by   #
'#                replacing lots of duplicated code   #
'#                with the new-brand function made by #
'#                me: "DrawFrame"                     #
'#               fixed MouseDown/MouseUp events so   #
'#                they now act as they should         #
'#               added MousePointer property         #
'#                                                    #
'# December 1  - 10:10 pm                             #
'#               replaced the RECT types assignment  #
'#                in the resize event with API calls  #
'#                that take 3/4 the time of raw vb    #
'#               added "use container" to the color  #
'#                schemes                             #
'#               button now initializes with it's    #
'#                caption set as it's name            #
'#                                                    #
'# December 23 - 2:00 pm                              #
'#               finally got all the code in API by  #
'#                replacing the Usercontrol.ForeColor #
'#                calls with CreatePen API            #
'#               added support for wrapping captions #
'#               changed a bit the XP button gradient#
'#                thanks to Ghuran Kartal for this    #
'#               added refresh sub to force a button #
'#                redraw.                             #
'#               MouseIcon property added            #
'#               MouseOver/MouseOut events added and #
'#                also a ForeOver property is provided#
'#                to change font color on mouse over. #
'#                this also fixed the WinXP button,   #
'#                which design is now perfect.        #
'#               added FlatHover button style that is#
'#                the real toolbar button.            #
'#                                                    #
'# January 1  - 11:15 am                 year 2002!!! #
'#               some minor fixes                    #
'#               new release!!!                      #
'#                                                    #
'# January 5  - 10:15 am                              #
'#               fixed the memory leaks (only 1% of  #
'#                gdi is lost per 15-20 runs of demo) #
'#               the font assignment has changed     #
'#               fixed a very rare and random bug in #
'#                the XP-button. Problem was in the   #
'#                DrawLine sub. Thanks goes to Dennis #
'#                Vanderspek                          #
'#               changed Mid and LCase to the faster #
'#                Mid$ and LCase$ way                 #
'#                                                    #
'######################################################

Private Declare Function SetPixel Lib "gdi32" Alias "SetPixelV" (ByVal hDc As Long, ByVal x As Long, ByVal y As Long, ByVal crColor As Long) As Long
Private Declare Function GetSysColor Lib "user32" (ByVal nIndex As Long) As Long
Private Const COLOR_BTNFACE = 15
Private Const COLOR_BTNSHADOW = 16
Private Const COLOR_BTNTEXT = 18
Private Const COLOR_BTNHIGHLIGHT = 20
Private Const COLOR_BTNDKSHADOW = 21
Private Const COLOR_BTNLIGHT = 22

Private Declare Function GetBkColor Lib "gdi32" (ByVal hDc As Long) As Long
Private Declare Function GetTextColor Lib "gdi32" (ByVal hDc As Long) As Long
Private Declare Function SetTextColor Lib "gdi32" (ByVal hDc As Long, ByVal crColor As Long) As Long
Private Declare Function DrawText Lib "user32" Alias "DrawTextA" (ByVal hDc As Long, ByVal lpStr As String, ByVal nCount As Long, lpRect As RECT, ByVal wFormat As Long) As Long
Private Const DT_CALCRECT = &H400
Private Const DT_WORDBREAK = &H10
Private Const DT_CENTER = &H1 Or DT_WORDBREAK

Private Declare Function CreatePen Lib "gdi32" (ByVal nPenStyle As Long, ByVal nWidth As Long, ByVal crColor As Long) As Long
Private Const PS_SOLID = 0

Private Declare Function CreateSolidBrush Lib "gdi32" (ByVal crColor As Long) As Long
Private Declare Function FillRect Lib "user32" (ByVal hDc As Long, lpRect As RECT, ByVal hBrush As Long) As Long
Private Declare Function FrameRect Lib "user32" (ByVal hDc As Long, lpRect As RECT, ByVal hBrush As Long) As Long
Private Declare Function DrawFocusRect Lib "user32" (ByVal hDc As Long, lpRect As RECT) As Long

Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hDc As Long, ByVal hObject As Long) As Long

Private Declare Function MoveToEx Lib "gdi32" (ByVal hDc As Long, ByVal x As Long, ByVal y As Long, lpPoint As POINTAPI) As Long
Private Declare Function LineTo Lib "gdi32" (ByVal hDc As Long, ByVal x As Long, ByVal y As Long) As Long

Private Declare Function CreateRectRgn Lib "gdi32" (ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Private Declare Function CombineRgn Lib "gdi32" (ByVal hDestRgn As Long, ByVal hSrcRgn1 As Long, ByVal hSrcRgn2 As Long, ByVal nCombineMode As Long) As Long
Private Declare Function SetWindowRgn Lib "user32" (ByVal hwnd As Long, ByVal hRgn As Long, ByVal bRedraw As Long) As Long
Private Const RGN_DIFF = 4

Private Declare Function GetClientRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long
Private Declare Function InflateRect Lib "user32" (lpRect As RECT, ByVal x As Long, ByVal y As Long) As Long
Private Declare Function OffsetRect Lib "user32" (lpRect As RECT, ByVal x As Long, ByVal y As Long) As Long
Private Declare Function CopyRect Lib "user32" (lpDestRect As RECT, lpSourceRect As RECT) As Long

Private Declare Function WindowFromPoint Lib "user32" (ByVal xPoint As Long, ByVal yPoint As Long) As Long
Private Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long

Private Type RECT
        left As Long
        Top As Long
        Right As Long
        Bottom As Long
End Type

Private Type POINTAPI
        x As Long
        y As Long
End Type

Public Enum ButtonTypes
    [Windows 16-bit] = 1    'the old-fashioned Win16 button
    [Windows 32-bit] = 2    'the classic windows button
    [Windows XP] = 3        'the new brand XP button totally owner-drawn
    [Mac] = 4               'i suppose it looks exactly as a Mac button... i took the style from a GetRight skin!!!
    [Java metal] = 5        'there are also other styles but not so different from windows one
    [Netscape 6] = 6        'this is the button displayed in web-pages, it also appears in some java apps
    [Simple Flat] = 7       'the standard flat button seen on toolbars
    [Flat Highlight] = 8    'again the flat button but this one has no border until the mouse is over it
End Enum

Public Enum ColorTypes
    [Use Windows] = 1
    [Custom] = 2
    [Force Standard] = 3
    [Use Container] = 4
End Enum

'events
Public Event Click()
Public Event MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
Public Event MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
Public Event MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
Public Event KeyPress(KeyAscii As Integer)
Public Event KeyDown(KeyCode As Integer, Shift As Integer)
Public Event KeyUp(KeyCode As Integer, Shift As Integer)
Public Event MouseOver()
Public Event MouseOut()

'variables
Private MyButtonType As ButtonTypes
Private MyColorType As ColorTypes

Private He As Long  'the height of the button
Private Wi As Long  'the width of the button

Private BackC As Long 'back color
Private ForeC As Long 'fore color
Private ForeO As Long 'fore color when mouse is over

Private elTex As String     'current text

Private rc As RECT, rc2 As RECT, rc3 As RECT
Private rgnNorm As Long

Private LastButton As Byte, LastKeyDown As Byte
Private isEnabled As Boolean
Private hasFocus As Boolean, showFocusR As Boolean

Private cFace As Long, cLight As Long, cHighLight As Long, cShadow As Long, cDarkShadow As Long, cText As Long, cTextO As Long

Private lastStat As Byte, TE As String 'used to avoid unnecessary repaints
Private isOver As Boolean

Private Sub OverTimer_Timer()
Dim pt As POINTAPI

GetCursorPos pt
If UserControl.hwnd <> WindowFromPoint(pt.x, pt.y) Then
    OverTimer.Enabled = False
    isOver = False
    Call Redraw(0, True)
    RaiseEvent MouseOut
End If
End Sub

Private Sub UserControl_AccessKeyPress(KeyAscii As Integer)
    Call UserControl_Click
End Sub

Private Sub UserControl_AmbientChanged(PropertyName As String)
    If MyColorType = [Use Container] Then
        Call SetColors
        Call Redraw(lastStat, True)
    End If
End Sub

Private Sub UserControl_Click()
If (LastButton = 1) And (isEnabled = True) Then
    Call Redraw(0, True) 'be sure that the normal status is drawn
    UserControl.Refresh
    RaiseEvent Click
End If
End Sub

Private Sub UserControl_DblClick()
If LastButton = 1 Then
    Call UserControl_MouseDown(1, 1, 1, 1)
End If
End Sub

Private Sub UserControl_GotFocus()
hasFocus = True
Call Redraw(lastStat, True)
End Sub

Private Sub UserControl_KeyDown(KeyCode As Integer, Shift As Integer)
RaiseEvent KeyDown(KeyCode, Shift)

LastKeyDown = KeyCode
If KeyCode = 32 Then 'spacebar pressed
    Call UserControl_MouseDown(1, 1, 1, 1)
ElseIf (KeyCode = 39) Or (KeyCode = 40) Then 'right and down arrows
    SendKeys "{Tab}"
ElseIf (KeyCode = 37) Or (KeyCode = 38) Then 'left and up arrows
    SendKeys "+{Tab}"
End If
End Sub

Private Sub UserControl_KeyPress(KeyAscii As Integer)
RaiseEvent KeyPress(KeyAscii)
End Sub

Private Sub UserControl_KeyUp(KeyCode As Integer, Shift As Integer)
RaiseEvent KeyUp(KeyCode, Shift)

If (KeyCode = 32) And (LastKeyDown = 32) Then 'spacebar pressed
    Call UserControl_MouseUp(1, 1, 1, 1)
    LastButton = 1
    Call UserControl_Click
End If
End Sub

Private Sub UserControl_LostFocus()
hasFocus = False
Call Redraw(lastStat, True)
End Sub

Private Sub UserControl_Initialize()
LastButton = 1
Call SetColors
End Sub

Private Sub UserControl_InitProperties()
    isEnabled = True
    showFocusR = True
    elTex = Ambient.DisplayName
    Set UserControl.font = Ambient.font
    MyButtonType = [Windows 32-bit]
    MyColorType = [Use Windows]
    BackC = GetSysColor(COLOR_BTNFACE)
    ForeC = GetSysColor(COLOR_BTNTEXT)
End Sub

Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
RaiseEvent MouseDown(Button, Shift, x, y)
LastButton = Button
If Button <> 2 Then Call Redraw(2, False)
End Sub

Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
RaiseEvent MouseMove(Button, Shift, x, y)
If Button < 2 Then
    If x < 0 Or y < 0 Or x > Wi Or y > He Then
        'we are outside the button
        Call Redraw(0, False)
    Else
        'we are inside the button
        If (Button = 0) And (isOver = False) Then
            OverTimer.Enabled = True
            isOver = True
            RaiseEvent MouseOver
            Call Redraw(0, True)
        ElseIf Button = 1 Then
            Call Redraw(2, False)
        End If
        
    End If
End If
End Sub

Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
RaiseEvent MouseUp(Button, Shift, x, y)
If Button <> 2 Then Call Redraw(0, False)
End Sub

'########## BUTTON PROPERTIES ##########
Public Property Get BackColor() As OLE_COLOR
BackColor = BackC
End Property
Public Property Let BackColor(ByVal theCol As OLE_COLOR)
BackC = theCol
Call SetColors
Call Redraw(lastStat, True)
PropertyChanged "BCOL"
End Property

Public Property Get ForeColor() As OLE_COLOR
ForeColor = ForeC
End Property
Public Property Let ForeColor(ByVal theCol As OLE_COLOR)
ForeC = theCol
If Ambient.UserMode = False Then ForeO = theCol
Call SetColors
Call Redraw(lastStat, True)
PropertyChanged "FCOL"
End Property

Public Property Get ForeOver() As OLE_COLOR
ForeOver = ForeO
End Property
Public Property Let ForeOver(ByVal theCol As OLE_COLOR)
ForeO = theCol
Call SetColors
Call Redraw(lastStat, True)
PropertyChanged "FCOLO"
End Property

Public Property Get ButtonType() As ButtonTypes
ButtonType = MyButtonType
End Property

Public Property Let ButtonType(ByVal newValue As ButtonTypes)
MyButtonType = newValue
If ButtonType = [Java metal] Then UserControl.FontBold = True
Call UserControl_Resize
PropertyChanged "BTYPE"
End Property

Public Property Get Caption() As String
Caption = elTex
End Property

Public Property Let Caption(ByVal newValue As String)
elTex = newValue
Call SetAccessKeys
Call CalcTextRects
Call Redraw(0, True)
PropertyChanged "TX"
End Property

Public Property Get Enabled() As Boolean
Enabled = isEnabled
End Property

Public Property Let Enabled(ByVal newValue As Boolean)
isEnabled = newValue
Call Redraw(0, True)
UserControl.Enabled = isEnabled
PropertyChanged "ENAB"
End Property

Public Property Get font() As font
Set font = UserControl.font
End Property

Public Property Set font(ByRef newFont As font)
Set UserControl.font = newFont
Call CalcTextRects
Call Redraw(0, True)
PropertyChanged "FONT"
End Property

Public Property Get FontBold() As Boolean
Attribute FontBold.VB_MemberFlags = "400"
FontBold = UserControl.FontBold
End Property

Public Property Let FontBold(ByVal newValue As Boolean)
UserControl.FontBold = newValue
Call CalcTextRects
Call Redraw(0, True)
End Property

Public Property Get FontItalic() As Boolean
Attribute FontItalic.VB_MemberFlags = "400"
FontItalic = UserControl.FontItalic
End Property

Public Property Let FontItalic(ByVal newValue As Boolean)
UserControl.FontItalic = newValue
Call CalcTextRects
Call Redraw(0, True)
End Property

Public Property Get FontUnderline() As Boolean
Attribute FontUnderline.VB_MemberFlags = "400"
FontUnderline = UserControl.FontUnderline
End Property

Public Property Let FontUnderline(ByVal newValue As Boolean)
UserControl.FontUnderline = newValue
Call CalcTextRects
Call Redraw(0, True)
End Property

Public Property Get FontSize() As Integer
Attribute FontSize.VB_MemberFlags = "400"
FontSize = UserControl.FontSize
End Property

Public Property Let FontSize(ByVal newValue As Integer)
UserControl.FontSize = newValue
Call CalcTextRects
Call Redraw(0, True)
End Property

Public Property Get FontName() As String
Attribute FontName.VB_MemberFlags = "400"
FontName = UserControl.FontName
End Property

Public Property Let FontName(ByVal newValue As String)
UserControl.FontName = newValue
Call CalcTextRects
Call Redraw(0, True)
End Property

'it is very common that a windows user uses custom color
'schemes to view his/her desktop, and is also very
'common that this color scheme has weird colors that
'would alter the nice look of my buttons.
'So if you want to force the button to use the windows
'standard colors you may change this property to "Force Standard"

Public Property Get ColorScheme() As ColorTypes
ColorScheme = MyColorType
End Property

Public Property Let ColorScheme(ByVal newValue As ColorTypes)
MyColorType = newValue
Call SetColors
Call Redraw(0, True)
PropertyChanged "COLTYPE"
End Property

Public Property Get ShowFocusRect() As Boolean
ShowFocusRect = showFocusR
End Property

Public Property Let ShowFocusRect(ByVal newValue As Boolean)
showFocusR = newValue
Call Redraw(lastStat, True)
PropertyChanged "FOCUSR"
End Property

Public Property Get MousePointer() As MousePointerConstants
    MousePointer = UserControl.MousePointer
End Property

Public Property Let MousePointer(ByVal newPointer As MousePointerConstants)
    UserControl.MousePointer = newPointer
    PropertyChanged "MPTR"
End Property

Public Property Get MouseIcon() As StdPicture
    Set MouseIcon = UserControl.MouseIcon
End Property

Public Property Set MouseIcon(ByVal newIcon As StdPicture)
On Local Error Resume Next
    Set UserControl.MouseIcon = newIcon
    PropertyChanged "MICON"
End Property

Public Property Get hwnd() As Long
    hwnd = UserControl.hwnd
End Property

'########## END OF PROPERTIES ##########

Private Sub UserControl_Resize()
    He = UserControl.ScaleHeight
    Wi = UserControl.ScaleWidth
    
    GetClientRect UserControl.hwnd, rc3: InflateRect rc3, -4, -4
    Call CalcTextRects
    
    DeleteObject rgnNorm
    Call MakeRegion
    SetWindowRgn UserControl.hwnd, rgnNorm, True
    
    If He > 0 Then Call Redraw(0, True)
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
With PropBag
    MyButtonType = .ReadProperty("BTYPE", 2)
    elTex = .ReadProperty("TX", "")
    isEnabled = .ReadProperty("ENAB", True)
    Set UserControl.font = .ReadProperty("FONT", UserControl.font)
    MyColorType = .ReadProperty("COLTYPE", 1)
    showFocusR = .ReadProperty("FOCUSR", True)
    BackC = .ReadProperty("BCOL", GetSysColor(COLOR_BTNFACE))
    ForeC = .ReadProperty("FCOL", GetSysColor(COLOR_BTNTEXT))
    ForeO = .ReadProperty("FCOLO", GetSysColor(COLOR_BTNTEXT))
    UserControl.MousePointer = .ReadProperty("MPTR", 0)
    Set UserControl.MouseIcon = .ReadProperty("MICON", Nothing)
End With

    UserControl.Enabled = isEnabled
    Call SetColors
    Call SetAccessKeys
End Sub

Private Sub UserControl_Terminate()
    DeleteObject rgnNorm
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
With PropBag
    Call .WriteProperty("BTYPE", MyButtonType)
    Call .WriteProperty("TX", elTex)
    Call .WriteProperty("ENAB", isEnabled)
    Call .WriteProperty("FONT", UserControl.font)
    Call .WriteProperty("COLTYPE", MyColorType)
    Call .WriteProperty("FOCUSR", showFocusR)
    Call .WriteProperty("BCOL", BackC)
    Call .WriteProperty("FCOL", ForeC)
    Call .WriteProperty("FCOLO", ForeO)
    Call .WriteProperty("MPTR", UserControl.MousePointer)
    Call .WriteProperty("MICON", UserControl.MouseIcon)
End With
End Sub

Private Sub Redraw(ByVal curStat As Byte, ByVal Force As Boolean)

'here is the CORE of the button, everything is drawn here
'it's not well commented but i think that everything is
'pretty self explanatory...

If Force = False Then 'check drawing redundancy
    If (curStat = lastStat) And (TE = elTex)ustom color
opB Thennatory...

If Forceex)ustomRter thell .Wriu = .ReadProperty("FCOL", GetSyL orm
End Sub

Private Sub UserControl_WriteProperties) As BooleaaaCAontrolperty("BTYPE", MyButtonTytroaty = .ReadPxloDitrol_Wl iteProperties) As BooleaaaCAontrolperty("BTYPE", MyButtonTytroaty = .ReadPxloDitrol( UserControl_WriteProperties) As BoBing ntrolperty("BTYPE", Mroperties) As BoBesPxlohing)
EnnnnnMyButtonTytroaty = .ReadPxloDitrol( UserControl_WriteProperties) As BoBing eP .Readtrol( UsBesPxlen S8rControl_Wrisv,l  sOol(s) As BooleaaaCAontrolperBrent MouseDup, a e Property Ge, -4,b redundol_WriteProbrolperBrent MouseDup, a e Property Ge, -rolpePropKeProbrolperBrennControlh-te Wi As Long  'the width of the button< dPxlodth obFon DrawPropertirdi Caption(ByVal newValue As String)
elTex(ByValtion(ByVal newValue nnnM, UserControlByVaetSysCmbien Property Get FontName(t  drawa_Wrie FontUnderlinCony...

 tption(ByVal r.E = .Rea height ofPiuseDup, a e Property GeL", BackCaoper) As BoBrty Ge,lFty("Fit will #
iesrol_Wrisv,l  sOol(s) As BooobrolperBrent MouseDup, ae Property GeL", BackCaoper) As BoBrt)
End Property

Public Poobrolpt)
ERe Pro MouseDuttonType = e Properierty Ge, -4,b redundol_WriteProbrolperBrent Mouep1 dPxlo= .ReadPxloDitrol(y22 ...
Xpented but troaty =d(ByV72 ...
XoWriteProbrrControlf thtHderControl_InitProperties()4adtrolContperBre bu  Wi = UserCoa..
XoWriwckCaopeaal_TertpaaaCAkCaoper) Ac
= tolf trierty Ge, -4,aty =d(ByV72 ...
XoWriteProbrrControlf thtHderControl_ICwill #
iesrol_Wrisv,l  sOol(s) As BooobrolperBrent MouseDulocWriwckCaopro MouseDuttonType =broisOol( ,b elTexOBrent MouseDulocIo= .ReadPxloDitrIc,aty =d(By, True)
    SyUp(Keyk
Public Poobrolpt)
E3 ..s, True)
    Sdng)   SyUp(Keyk
kdng)  ouseDulocIo= XoWriteProbrrControlf thtHderPik()
Public Event MouseDown(Button As Inte:nnM, UserControlByVaetSysCmbien Property Get FontName(t  drawa_Wrie FontUrIc,aty ng  ' 'Proprie FontUrC_Wrie FontUrIc,aty eINKdFontUrIcsrit eINKdFed b) As BoBrt)
End Property

Public Poobrolpt)
ERe Pro MouseDuttonType = e Properierty Ge,brrS

Public Poobrolpte ..s, True)

 Ti1ell(rty Ge,brontUrCe,brrS

PublicXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXsDControlByVaetSysCmbien Prope1m$lFontNXXXXXXXX(eUrIcsrit e$lFontNXXXXXXXX(XXXXXXXXX(eUrIcsrit e$lFondysColor(COLOR_BTNTEXT))
  XXXXXXXX(eUrIcsrit e$lFontNXXXXXXXX(XXXXX Po,SsXXXXyV72 ..itePrmsCmbien Prope1m$lFontNXXXXXXXX(eUrIcsri bsXXXt.itsXXXnoDitreUrXXXXX Po,SsXXXXyV72 ..itePrmsCmbien Prope1m$lFontNXXXXXXXX(eUrIcsri bsXXXt.itsXXXnoDitreUr ien Prope1m$lFontNXXXXXXXX(eUrIcsrit e$lFeUrI hr ien Pr[nd Property

PublbsXDulocsrir FeUrI hr De9etSyivate SulFeUrI hr ien Pr[PropertniaeaXXXXXXXXXsDControlBwerty

PublbsXDulocsrir FeUrI hr Dier, Shift As Integer,>lFontBold(ByVal newVv0XXXdGet FontIttPo,Siift Asn Pr[newtublbst De9eulocSulet FontIttPo,Siift Asn Pr[newtublbst De9eulocSulet FontIttPo,Siift "y

riteProperttton, everyt1FontIttPo,Siift Asn RE of thlocSmttton, everyt1FontIttPo,SiiftT

Public Property Geulocsrir FeUrI hr Dier,hr Dier, ShHEthing is
ll CalcTlicner,hr DntNXXXXXXXX(Xpert
PublrRCc PtdPropI hr ien Pr[Propertniaer,hr Dier, ShHEthinblrRCc PtdPropI hr ien Pr[Propertniaer,hr Dier, Sh ontrol0den0r ButlrRDitrl  sOol(s) As BooleaaaCAontrolperB0er,hr Dier, toleeeeeeeen0nt AscohOol(s) As BlTeegB0er,hrnsOol(s) As BooleaaaAscohOol(s) As BlTeegB0er,hrnsOol(saetSysCmbien Pro eeeen0ntoeIlScTlicnntrol.font)
tonType = e Properierty Ge, -4,b redundol_Writb ) As el
hhty Gehr Dier, toleeeehwndy Ge, -4ong, cTeAUrI hr ien Pr[nRr Dieiift           XXXXXwndy Geeeehwndy2DControCa0en Pr[nRr Dieiift          ?l)
eeeehwndy2DContre>ti]yy!lties(PropBag As PropertyBag)
hwndy2DContre>ti]yy! is
ll i]yy!lties(dfroperty Let ForeOver(ByVal theCol eGulocSulet FolPropertyBag)
hwndy2DContre>ti]yy! is
ll i]yy!ltiesw>ti]yy! is
ll i]yy De9ey = .Ro trolr[ProemEF eGuloWies...............rIcsrit e$lFltrolr[PrPr =d(By, True)
    SyUp(KeyhM[ProemEF eGuloWies.lTeegB"tfCtoleeeehw0tnUeiift       iteProperti e Pro= .Read9ey = .Ro t2all i]yy!1VaeEPubliegB"tfCtoltUrCe,brrS

PublicXXXXXXXXRI hr De9etSyivate SulFeUrI h0l i]yy!1VaeEPubliegB"tfCtoltUrCe,brrS

PAsn Pr[neweeeen0ntoeIlScTlicnntrol.font)
true)
  i]yy!1VaeEPubliegB"tfCtoltUr=d(By, !1VaeEPubliegB"tfCtob)
    SyUp(KeyhM[ProemEF eGuloWies.lTeegB"tfCtoleeeeeeeeeeeeeee1VaeEPubliegB"tfCntreffAscii A!1VaeEPubliegB"tfCkll i]yy!1VaTRGe, -rolpePropKePro0RI hr De9etSy!lti]yy!1VaT Redraw(0, True)
End   SeulocONT", UserControl.font)
    MyColoeeeeee'csrit
ro0RI hr De9etSy!lti]yy!"tfCtolta.font)
c]yy! is
ll i]yy!ltiesw>ti]yy! is
ll i]yy De9ey = .RlrRDitrl  sOobntroSC
ro0RI hreDup, a                in tlpePropKePro0RI hr De9etSy!lti]yy!1VaNTypeywdhn0n]yy De9eyt)
c]yy!8l>ti2Cee'csrit
ro0RI "tDup, a         c)kberFlags = "400en Prl>ti2Ce,3 dundol_Writb ) As el
hhty Gehr DleIs el
hhty GR        c dundvate SAs el
hh.......rIcsrN  drawa_Wrie Foti2Ce,3 XXXXX c dundvate l>ti2Ce,3 dundoltom colcyy!1XXXXXXX        c)kberiate l>ti2Ce,3 duR2ocyy!erythUrXXXXX Po,SsXXXXyV72 ..itePrmsCmbien Prope1m$lFontNXXXXXXXX(eUrIcsri b   c)kberiate l>ti2Ce,3 duR2ocyy!ery! is
ll i]yy!ltiesw>ti]yylScTlicnntrol.font)
true)
  ItrolContfLntrfont)
true)
  i]yy!1ci2Ce,3 iti]yylouseDuttonType = e Properienee =eegB0er,er lmr.3OL"O2mrO2mrO2mrO2mrO2m is
lPCtol MouseIegB0eoHEthing is
 lmr.3OL"O2mrO2mrO2myneUCalcTextRects
Call Redraw(0, True)
End Property
IhUrXXXXX Po,SsXXXXyV72 u l> colcyy!1b2ouseDuttonTytre>t>3OL"O2mrO2mrO2myneUCalcTe()4adtrolContperBre 

PublicXXXXXXXXXXXXXXXXXXXc
   neawa_Wrie FEhr ien XXXXXXX5ift Aol0den0r Butlrien Xf  i]y ty

'####nhng is
ll Cal olCont plicO.Prop f  i]y ty

.Prop f  i]y ty

.Prop f egB0etlri
Call Redraw(0, True)
Cs
PubX    ytre>t>3OL"O2mrO2mrOAsop f  i]y ty

.Prop f  i]yLblic Po
With PropBaRXXXXX Po,SsXXXXyV72 u l> colcyy!1b2ouseDuttueaaa3  !gaHIPo,airtniaer,hr Dier, Sh ontrol0den0r ButlrRDitrl  sOol(s) y("BCOL9eulrl  sOol(s) y om color
i2 u OL9euSh rnrtniaeR0r ecgV72n0r f   ran)
User
Call Rul= .Ro tAAAAAAAAAUrIcsri b  y
IhUrXXXXX Po,SsXXXXe1m$l itroaty3Property

Public PoobrolpteGet FontSize()er,hr Dier, Sh ontrol0den0r ButlrRDivate SPtNXXXXXolptRXXXXXXXXXXXXXXXXXuolContperBre hUrXXX44444444444444444444444wContperBre hUrXXX44444444444 Truea 444444444wContperBre fer(Byx
true)
  i]yy!1ci2Ce,3 iti]yylouseDu,FbnhFbnhF1b2ouseDuttuea5myneUCalcTe()4adtrolContperBreContperBre hUrXXX44444444444 XvrolCrl  sOol(s) y("B Bre L4444444     4adtrolContperBreContperBrDadundoltom c
ontperBreContperBrDare hUrXXX44444444444 XvrolCrl  sOol(((((((((((((eDu,FbnhF.lTeegbnhF.olCrl  sOol(s) y("B Bre L4444444     4adtrole)
RaisntperBreCa0en PCrl  sOol(((((((((((((eDu,Fbnhrop f3OLfX44444444444 TCrl  sOog L444444

PublisXXXXe1m$l itroaty3ProtperBbu
Public(((((((! is
hhleegB0ublisXXXXe1c"aIttPo,SiiftTet
ro0RI hY   neawt De9eulocSulet FontIttPo,Siift AsHaKrnl(s) y olecgV72n0r f   ran)
User
Cal B44

 neawtawtawtawtawtawtawtawo troF(ByVal ulocSuleulocSuleulocSuleulocSuleulocSuleulocSuleulocSuleulocSuleulocSuleulocf egB0etlUser
C4

 neawta dull(s) neawtawtawtawtawtawtaworType = .ReadProsAueeLfX44444hY PrmsocSulatyXXXXXXXXuolCo?l)
eeeehwndy
's)n PrmseContperBedraw4444444444 TrrBedraw4444444444 TrrBedraw44444444 Lkberi2 FolPropertyBag)
hwndy2DConhr Die44 Lkberiroperttaw4eSulocSuntperBkberiropertta/ublic Poobrolpt)
Elocs
PuBedrauntpeD-V72n0r f   ran)leulocSuleulo2n0r f   )
ElocsocSulatyXXXcCm$l itroatyTytro trol.MousePointer =Pshwnde
Eloco)
EleulreContperBrDaaaaaueaa wiSMsocSulatyXXXcCm$l itroatyTytro trol.Mouet Foro trol.Mc4444wContperBiRitroatePointer()eaa wiSMsocSu  pteGet FontS e>t>3OL"O2mrO2mrOAsop f eColor = BackC
locSuleulocf Lol.Mc4444wCcxXX(eUrItperBiRitroatePoinmnt MousrroatePoinmntHsOol(eulocSuleu44wCcxXX(eUrItperBiRitroaPAsop f eColoFL PoobItperwiSMsPoinmntHsOol(ereCo! ist() As Boolean
ShowFocusRLfX444wCcxXX(eUrItperBiRitroaPAsop f eCom_Bre 
asOol(s) y(howFocusRLol(ereCo! ist() As Boolean
72n0r f  CaoyrIcsr eColoFL PoobItperwiSMsPoinmntwoaPAsop eColoFinmntwoaPAsop 2obItpeehwnsXXXXe1cnaa wiSMspaloFinmntwoaPAsow44444444sl>ti2Cee'csrit
ro0RI "tDoperwi(erE Y PrmsocbliegB"tfa Lol.Mc4444wCcxXX(eUrItperBsoyrIcsr eColoFLdfe'csod,FL PoobItperwiSMsPoinmntHsOol(ereCo! ist() As Boolean
Sh oatePointer()eaa wiSml.Mc4444wCcxXX(eUr
ShowFocusRLfbPAsop eColoFi44     4adt,ocustre>ti]yy! is
llFi44     v oXXXXXXi44 erE Y44wCcxXX(eUrItp)cxXX(0 erE Y4B"tf.itePrmIncId locSuntoFinmntwb DS(eUrntwb DS(eUrnterE Y44wX44wXXXXiDeadProsAuee,nbtrol.font)RS21VaNrhvl
hhty GehiProp.Mc4,'csu,FbnhFoSntera hreDup, a Cee'I4wCcxXDS(eUrntwbConhr Die44 LeUrntwbConrE Y44 "(eUrnterErmIncId locSureCo!fGehiProp.Mc4,'csuVaeEPubliegB"(eUrnterErmIncId locSureCo!fGProsAuee,nbByx
tswtawn D   fc=TXXXX Po,SsXXXrPoobItperwiSMsPoinmnrDadiMc4 fc=TXXXX PoXXrPoobItp  CaoyrIcsr eCw.
XoW_eaadiMc4 fc=TXX!g  SRTXXX Po,SsXXXr ObXrPoobLfbPcSureCo!fGProsAuee,nbByx
tswtawn D irE Y4B"tr ObXrPoobLfbPcSureCo!fGProsAuee,nbB TXXrlic Property Let Enabled(ByVal newValue As Boolean)
Let EnableSRI hreDu1b2ouseDuttue,sfxnl Boolean)
Let EnableSRI hrcTextRectl>tiiuseDuttue,sfxnl Beaaolean)4 Boolean)
Let EnableRectl>tiiuseDuL,nbByx
tswtawn D irE Y4B"trFng isseDuttue,sfxnl Boolb  fc=TXXXX _EnasPoinectl>tiiuseiiuseeblic Property Get MouseIcon() As StdPicture
    xnl Beaaolean)4 Boolean)
Let EnableRectl>tiiuseDuL,nbByx
tswtawn D irE Y4B"trFnarg  SRTXXX Po,SssY4B"tr          fc ableRectl>tiiuseDuL,nbByx
tee,nbB TXarg  SRTneawP hrcTextT84 eRI hrcnderline.teguan
EnablePo,SssY4B"tr  Eg'ContperBre hUtperBre hUtpeTOhontperBrreContperBrDadundoltom c
ontperBreContpOeSssYrDadiMEl Boolean)
Let EnableSRI hrStdPicture)
Olocs
PuBedry
tsmrO2mynenableSRI hrStdBoolehe EnableSRI hrStdPicture)
Olocs
PuBedrD2 Set"ETnearSt4     v0"tr }XXX Po,SssY4B"tr       .Ro t2all i]yy!1VaeEPubli'RI  Po,SstwFocusRLfbPAslSssY4B"tr     dry
    lePo,SseDu,FbnhFbnhF-LfbPLfX4rE Y4B"tr7aeSRI hrnt.
EleulreCont As REC.Po,SseDu,FbnhFbnhF-LfbiuseDuL,nbByx
A  dry
     ran)leuloed(ByVal newVv0XXXdGe0bws) y sOedrD2 Set"ETnBSet"ETnBSblbselean
72n0r f  Mc4 fc=TXX444444 TrrD2 STruea 4444awa_Wrie FonterD2 STruea 4444awa_Wrie FonterD2 STruea 4444awa_Wrie FonterD2 STruea 4444awa_Wrie4444awa_dsruea 4444awa_T.e44444444444wContperBrersrie F pTRs4awa_ -44444444e
hwndyMtea_T.e44444444444wContperBrersrie F pTORE of the butBoollinae4e
hwndyMtea_T.e44444444444wContperBrRControl.FontItalic = nee hrcTextT84 eRI hrcnderline.teguan
trol.FontISen a 4ntperBrktBoolinei neanei neanyTytro trp eItalic = nee hrcTextT84 eRI hrcnderline.teguan
euloed(Bline.te.teguan
euloeeine.NuX Po,SsXXXr ObXrPoobLfbPcSureCo!fGProsAuee,nbByx
tswtawn D irE Y4B"tr ObXrPoobLfbPcSureIx
ta. f  Mc4 fc=TXX444444 TrrD2 STrueaeIx
teenableSRI hrStdPictfbPcSureCo!fGProsAuee,nbByx
tswtawn D irE Y4B"tr ObXrPoobLfbPcSureCo!fGProsAuee,nbB TXXrlinterEEu44wCoJc=TXX!g  SRTXXX Po,SsXXXr ObXrPoobLfbPcSureCo!fGProsAuee,nbByx
tswRI hpEy1U%PubliegByx
tswRnabled = newValue0uloeeine.NuX Po,SsXPne.te.teguan
euloeeine.NuX Po,SsXXXr ObXrPoobLfbPcSureCo!fGProsAuee,nbByx
tswtawn D irE Y4B"tr Obyx
tswRI hpEy1U%hForeOver(ByVal theCol eGulllllsruea 4444awa_@ce20oobLxeyy

Publ4Wdeey1UF pTRs4aw }XXX Po,SssY4B"tr       .Ro t2all i]yy4ed(ByErE Y4 pTRs4aw }XXXontperBrDaip0peD-V72e 444U%hFUF pTRs4perwiSMsPoinmntHsOol(ereC/GehiProp.Mc4,'csu,F of the butBoollinae4e
hwnd Jc=TY Pr,s0SSSSSS0SSSSSS0pTRs4awireOverSureCo!fGProsAuee,nbByx
tswRJc=TY ProsAuicr(RhreDup, a Cee'I4wCcxXDS(eUrntwbConhr Die44 LeUrntwbConrE Y44 "(eUopertyLUrntwbCoIiysycLd>_@ce20ooxol.McawbConrE Y44 "(eUoxeyyde8cLd>_@rSley1UVal nLeUrntwbCswtawn D irE Y4B"tr Oby eGulocSulet FolPropertBPc4444CvPcSoobLfbPcSureCo!fGPrnLaulocSulet FolPropertBPc4444CvPcSoobLfbPcSureCo!fGPrnLauloocSuuloocSuolsruea 4444awa_@ce20oobLxeyy

Publ4Wdeeyic Event MolsruPropertBPc44,c Eventtawtawo troF(8cLysrcnderline.t_F ?l)
eeOsoa 4444awa_Wrie FonterD2 STruea 4444awa_Wrie444.4B"tr       . Property Let4444ALxeyy=P)x
A  dry
   he bnveau
C4

 neeegB0W4perwiSMsPoinmntHsOol(Po,Siift Asn RE of thlocSmttton, everyt1FontIttPo,SiiftT

PublicLfbPAslI Asn RE of thlocSmttton, everyt1FontIttPo,SiiftT

Pubnwtawo troF(8cLysrcnderline.t_font = .w of thlocSmttton, everyt1FontIttPo,SiiftT

Pubnwtawo troF(8cLysrcLd>_@ce20ooxol.McawbConrE YveryEvent Molsr&E ofaiifoxol.McawbConrE osAuc(EnabttPo,SiBGehbXrPoobLfbPcSureCo!fGProsAuee,nbByx
tswRI hpEy1U%PubliegByx
tswRnabled = newValue0uloeeine.Nunaet4

PubnwtawoErE Y4 pTRs4awley1UVal nLeUSiif1pS1Fon iaaetwbE YverPubnwtawoErE Y4 pTRs4awley1UVal nLeUSiif1pS1Fon iaaetwbE YverPubnwtawoErE Y4 pTRs4awley1UVal nLeerPB=CvPcSodS1Fon iaaetwbE YverPubnwB=CvPeawleyY4B"tr ObXrPoobLfbPcSie'srcl nLeoeveryt1Fon8UVal nLeerPB=xU%hFU
:LeUSiif1pS1Fon ioioioioioioioioioioioioioVal nLawireOverSaawireOveureCo!fGProsAue, everyt1FontIttPo,SiiftT

Pubnwtawo troRs4awleyD..rtwn ioioiLEb tItteOveu1Siiftbled = newVteguan
euloed(BlincId locSureCweyY4BvioiLEb tIttendeetrpe 444U%hFUF pTRs4perwperwperwperwperwperwpeU%hFFFF>rwperwperwperwperwrwiSMsPoieveryt1Fon8UVaeveryt1FonEwETn) y("B Bre L4444444   vof1pS=dcFontNXXXwbCsweUVal nLewValHcSmttton, everyt1FonteulreNEO'Val nLeerPB=xU%hFoemEF eGuloWies.ureCweyY4Bn D irE Yap nLewValTRs4perRsrcnderline.t_F ?l)
eeOsoa 4444awa_Wrie FonterD2 STruea 4444awa_WrdmraCGehiPre3  i]y ty

.Pry1UVHTrue'eoFbPAsop eCoePubnwtawo troRs4awleyD.2 STru_F ?kYap oiLEb tIp
eeOxe1ftleyDsoa 4o,SiiftT

PuadeyDsoa 4o,SiiftTOxe1-cltT

PrwperwperwpeU%hFFFFubnwterwperwpTsHaKrnl(s) y olec oErE Y4yx
perwperwperS0SSSSSS0pTRs4aw=TXXXX Po4yx
pere FonterD2 deyDsuan
trerwpeU%hBperwpe-s, cerwpe=X P  pe-s(TOxe1-cltT

w=TXRrwperwperwpeU%hFFFFutc_Wri
PrwperwperwpeUf1pSetE0FFFF>rwperwperwperwperyo0TDewpe=X erwpe Y4yx
perolec oErE Y4yxnl(s 4444aeeiiftTOxerwpetSnl(sttendeetrpe 444U%hFrwperl nLeerPB=xU%on) ery
s 4444aeeiiftTOxerwpetSnl(gB"(eCcFuseI0e 444U%FPropcFniElptRXXXXHFPropcFnperwperwperwt]aeeiift=X P  pe-s(TOxe1-cltT'_F ?kYapyt1FonEwETn)tSniB'erolContt _F     ,BntervntervntervntervntervVyx
.olCrl drD2 Sefl*ShirPB=BntervntervntervntervntervVyx
.olCrl drD2 Sefl*ShirPB=BntervntetirPB=BntervntervntervntervntevntervnterirPBrue'eoFbPAsdS1Fon  TnrvVyyn
euloed(BmP444aeerPBrue'eoFbPAsdS1Fon  TnrvVyyn
euloed(BmP444aeerPB en  TnrvVPCElprPBopes 4444aeeo s(TOxseDu,FbnhFbnhFWwperwperyo0TDX444Siif1pthpEyaw=TXXXX Po4yx
perOhu.0aerwp C 13.ro tVyyn
euloed  TnrvVyyn
euloed(BmPM"() As ColorTypes
ColorSchhdeCrl drD2 Sefl*ShirPB=BntervntetirPB=BntervntervntervntervntevntervPAsdS1Fon  TA)0hen 'rdervntetileBStervntervntecervcntese(BmPM"=is
s 4444aeeiiftTOxerwpetSnl(gB"(eCcFuseI0we(BmPM"=is
s ncervt44SrntwbBmPM"=is
s ncervt44SrntwbBml(gB"(eCcFuseIwTCsOwB=CvPeawleyY4B"tr C 13.ro tVyyDlM4Srnt4SrntwbBPonw
s ncervt444SrntwbBml(gB"(eCcFusty

vt44S=RmervnC4Bml(tidSrntwbBmPM"=is
s ncervt4rvnC4Bml(tidSr wTCsiLeoeveryt1Fon8UVal nLeerPB=xU%hFU
:LeUSDE

vt44S=RmervnC4 ncervt44SrntwbBmP4S=RmervnC4Bml3RcocsrwVyx
.olCreplMB"(eCcFusty

e Y PrmsocbliegB"tfa Lol.Mc4444wCcxX"(eCcFscervt4eRoos
4B"tr C 1(eCcFusty

eee44Srntwtfa Lol.Mc4444wCcxX"ntwbhn0yt1FontI=sOontervtty siwCcxX"(eCcFsce7  lEdS=Ro tVyyDlM4Srnt4(ynwperwperyo0TDewpe=X erwpe Y4yx
perolec oErE siwCcxX"(eCcFaTReFaaPrwperwperwpeUf1pSetE0FFFF>rwperwpePB=BntervntervntervntervntevntervPAsT(=X erwpe Y4yx
perolec oErE siwCcxX"(e.kRiaer,hr Dier, Sh ontrol0den0r ButlrRDitrl  sOol(s) y("BCOL9eulrl  sOol(s) y om color
i2 u OL9Ditrl  sOPrwperwperwp
 .kRirntwbBmPM"=iservnteimColo1TyaTRep
 .kRirntwbBmPM"=iservnteimColo1TyaTRep
Rs4awle05APM"=iservnteimColo1TyaTRepIb.Mc444APM"=is
i2 oervnteimColo1Tyafont = .w of thlocSmttton, ocs
PuBedry
ts44Siif1mc .kRirntwbBmP
srE sxycSmttton, ocs
PuBedry
ts44Sis 4  ts4l.Mc4444wCcxX"(cs
Ph"CcxPoobLt444APM"=is
i2 oervnteewVteguan
e Mc4Dsoa 4oOL9eulrl  sOol/rE Y4B"yyDs 4  tsrS0SSSSSS0pTRs4aw=TX2 irEWritevnteMc4L guaPM"=is
sOol(s) y("BCOL9eulrl  sOoLEPonw
s ncervca4L guaPM"=is
sOol(s) y("BCOL9eulrl  sOb  sOos ncervca4L guaPhrwVyx
.orEWritel  sOoLEPonw
saPhrwVyb  sOos ncervca4L guaPtwbBmP4S=RmervnC4Bml3RcocsrwVyx
.olCrMBmPM"L guaPtwbBmP4uBedry
ts44wbE YverPubnel  s YverPubn(((((vntervntervnte guaPtwbBmP4uBedry
ts44wbE YverPubnel  s YverPubn(((((vnterhFc siwCcxX"(eCcFaTReFaaPrwperwperwpeUf1pSeL guaPtwbBmP4uBedrVhin((s44wbE YverPubX"(eCah)en Prope1m$lFontNXXXXXXXX(eUrIcsri bsXXXt.itsXXXnoDitreUr X"(cspie$lFontNXXXXXXXX(eUrIcsri bsXXXt.itsXXXno(csp ri bsXXXt.itsXXXnoDitreUr X"(cspie$rr}Vyx
ervrPubrol.rs2 oerliX  %hFe$r lliX  %hwbBmCall Redraw(0, True)
End Property
IhUrXXXXX Po,SsXXXXyV72 u le2on, s YverPubn(((((vntesXXX9uaPhrwVyx
.  Frty
rrrrrrrrrrrTreUr X"(cspie$rr SXnoty
y
rs4  tsrS0SSSSSS0pTRs4aw=TX2 irEWritevnteMc4L guaPM"wpePB=Bntervntervn
IlCrMByaTrwpeUVal nLeerPB=xU%hFU
:Lvnteren Prope1m$lFontNXXXXXXXX(eUrIc guaPM"ean)4 Booed(
FontXXXXXXnontNX1n Prope1m$lFontNXXXXXXXX(eUrIccoTbBmP4S=RmervnC4Bml3RcocsrwVyx
.olCrMf XX(eUr,E YveLeerpe1r}Vyx
ioVal nLawireOverSaawireOveurWntNXXXXXXXX(eUrIcc1n PropewTCsiLeoeveryt1Fon8UVal nrpe1rntNXXXXXvnterhFcawa_WrieXXX Po,SsXXXXyeUVal nLee>O1rntNXXXXXvntrhFcaBmP4S=RmervnC_WrieXXX Po,SsXXXXb2nrpe1rntNope1byeUVal nerwperwpWritFFVaeveryt1FonEwETn) y("B Breryn = 1onCrBkberiropitevM PropewTCsiLTn)rvnC_WrieXXds= 1onCrsyn = 1onCrBkberirValueXXXXb2nrpe1rntNope1beXXX Po,SsXXXXyeUj 1onCrBkberirValueXXXXb2nrpe1rntNntNo3srwVyx
tXXXb2nrpe1rntNntNo3srwVyx
tXXXb2nrpe1rfl3RrIcsri bsXXXt.itsXXXno(csp ri bsXXXt.itsXXXnoDitreUr X"(cspie$rr}Vyx
ervrPutNo3srwVbuaPt=terhFcawa_WepDProsAuee,nb'brol.rsrpe1rntNntX P&o4yx
perOhu.0aerw 
Ils"(corS0SpDProld,sDProeSsXXXXyeUVal fo!fGProsAuee,uw 
Ils"(corS0SpDProld,sDProeSsXXLeulrlBre hUtperBre haMBa 444rrxuwHc,hr Dier, SFeuloed(BmP444aeerPBrue'eoFbC4SS0pTRs4aw=TX2 irEWrite}Vye) er14aw=TX2 irEWritCsiLTn)rg er1Ntroldervrvt44SrntwbBebBebBebBebBebBebBebBebBebBebBebBebBebBebBebBebBebBebBebBebBebBebBebBebBebBebBebBebBebBebBebBebBebBebBebBebBebBebBe